#define _CARGADOR_MOD_

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "CargadorMOD.h"
#include "texture.h"
#include <gl/gl.h>
bool CargaObjetoMOD(char *mod,objMOD *obj)
{
objMOD aux;
FILE *f;
char nombreTex[256];
int i,j,entero;

	if((f=fopen(mod,"r"))==NULL)
		return FALSE;

	fscanf(f,"NUMERO DE PUNTOS = %d TIPO = %d\n",&aux.nptos,&aux.tipo);
	aux.ptos=(float **)malloc(aux.nptos*sizeof(float *));
	for(i=0;i<aux.nptos;i++)
		aux.ptos[i]=(float *)malloc(13*sizeof(float));
	for(i=0;i<aux.nptos;i++)
	{
		fscanf(f," %d **",&entero);
		for(j=0;j<13;j++)
			fscanf(f," %f",&aux.ptos[i][j]);
		fscanf(f,"\n");
	}   
	if(!feof(f))
	{
		fscanf(f,"%s\n",nombreTex);
		aux.textura=CargaTextura(nombreTex);

	}
	else
		aux.textura=-1;

	*obj=aux;

	return (TRUE);

}

void DibujaObjetoMOD(objMOD obj)
{
int i;
  glPushAttrib(GL_TEXTURE_2D | GL_CURRENT_BIT);

	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
	
	glDisable(GL_CULL_FACE);

	if(obj.textura!=-1)
	{
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, obj.textura);
	
	}
	switch(obj.tipo)
	{
		case 1:
			glBegin(GL_TRIANGLES);
			
				for(i=0;i<obj.nptos;i++)
				{
					glTexCoord2f(obj.ptos[i][11],obj.ptos[i][12]);
					glNormal3f(obj.ptos[i][4],obj.ptos[i][5],obj.ptos[i][6]);
					glVertex3f(obj.ptos[i][0],obj.ptos[i][1],obj.ptos[i][2]);
				}

			glEnd();
			break;

		case 3:
			for(i=0;i<obj.nptos;i++)
			{

				if(obj.ptos[i][3]==1)
					glBegin(GL_TRIANGLE_STRIP);
				glTexCoord2f(obj.ptos[i][11],obj.ptos[i][12]);
				glNormal3f(obj.ptos[i][4],obj.ptos[i][5],obj.ptos[i][6]);
				glVertex3f(obj.ptos[i][0],obj.ptos[i][1],obj.ptos[i][2]);

				if(obj.ptos[i][7]==1)
					glEnd();


			}
			break;
	}

 glPopAttrib();

}